package;

import hage.HGE;
import hage.HGESprite;
import hage.HGEUtils;

/**
 * ...
 * @author JanGamesCo
 */
class PowerUp extends HGESprite
{
	public static var puplength:Int = PowerUpType.getConstructors().length;
	
	public var powerup:PowerUpType;
	private var speed:Float = 100;
	
	public function new(X:Float=0, Y:Float=0) 
	{
		super(X, Y, 32, 16, 0, 1);
		
		//powerup = PowerUpList.createByIndex(Math.floor(Math.random() * PowerUp.puplength));
		powerup = HGEUtils.weightedRandom(Data.the.powerUpsVals, Data.the.powerUpsWeights);
		
		switch (powerup) 
		{
			case LARGER:
				color = 0xFF8080FF;
			case SHORTER:
				color = 0xFF4040FF;
			case LAZER:
				color = 0xFFFF4040;
			case MAGNET:
				color = 0xFF606060;
			case DOUBLE:
				color = 0xFFFFFF40;
			case TRIPLE:
				color = 0xFFFFFF00;
			case SLOW:
				color = 0xFF404040;
			case FASTER:
				color = 0xFFFFFFFF;
			default:
				color = 0xFFFFFFFF;
		}
		
		Data.the.powerups.push(this);
	}
	
	override public function update()
	{
		super.update();
		
		y += speed * HGE.delta;
	}
	
	override public function kill() {
		super.kill();
	}
	
}

enum PowerUpType {
	LARGER;
	SHORTER;
	LAZER;
	MAGNET;
	DOUBLE;
	TRIPLE;
	SLOW;
	FASTER;
}